import { IQueryHandler, QueryHandler } from '@nestjs/cqrs';
import { GetRouteQuery } from './get-route.query';
import { RouteEntity } from '@modules/geography/core/domain/route.entity';
import { Inject } from '@nestjs/common';
import { GEOROUTER } from '@modules/geography/geography.di-tokens';
import { GeorouterPort } from '../../ports/georouter.port';

@QueryHandler(GetRouteQuery)
export class GetRouteQueryHandler implements IQueryHandler {
  constructor(@Inject(GEOROUTER) private readonly georouter: GeorouterPort) {}

  execute = async (query: GetRouteQuery): Promise<RouteEntity> =>
    await RouteEntity.create({
      waypoints: query.waypoints,
      georouter: this.georouter,
      georouterSettings: query.georouterSettings,
    });
}
